#include "stc8h.h"       //ͷļ󣬲Ҫٰ"reg51.h"ͷļ
#include "stdio.h"
#include "intrins.h"
#include "USB.h"

typedef 	unsigned char	u8;
typedef 	unsigned int	u16;
typedef 	unsigned long	u32;

#define MAIN_Fosc       24000000L   //ʱ

/****************************** û ***********************************/
#define Timer0_Reload   (65536UL -(MAIN_Fosc / 1000))       //Timer 0 жƵ, 1000/
/*************  ر    **************/
bit B_1ms;          //1ms־


#define PWM3_0      0x00	//P:P1.4  N:P1.5
#define PWM4_0      0x00	//P:P1.6  N:P1.7

#define ENO3P       0x10
#define ENO3N       0x20
#define ENO4P       0x40
#define ENO4N       0x80

#define PWM_PERIOD  1023    //ֵ

/*************  غ    **************/

void UsbInit();
BYTE ReadReg(BYTE addr);
void WriteReg(BYTE addr, BYTE dat);
BYTE ReadFifo(BYTE fifo, BYTE *pdat);
void WriteFifo(BYTE fifo, BYTE *pdat, BYTE cnt);

void Timer0_Config(WORD tReload);
BYTE GetCheckSum(BYTE *buf, BYTE len); //ȡУ

u16 PWM3_Duty;
u16 PWM4_Duty;

bit PWM3_Flag;
bit PWM4_Flag;

void PllConfig(void);
void HSPwmConfig(void);
void UpdatePwm(void);

void DelayXms(unsigned int time)	//@24.000MHz
{
	unsigned char data i, j;
	for(;time>0;time--)
	{
		_nop_();
		i = 32;
		j = 40;
		do
		{
			while (--j);
		} while (--i);
	}
}

void main()
{
  BYTE i;

  P_SW2 |= 0x80;  //չĴ(XFR)ʹ

  P0M0 = 0x00;
  P0M1 = 0x00;
  P1M0 = 0x00;
  P1M1 = 0x00;
  P2M0 = 0x00;
  P2M1 = 0x00;
  P3M0 = 0x00;
  P3M1 = 0x00;
  P4M0 = 0x00;
  P4M1 = 0x00;
  P5M0 = 0x00;
  P5M1 = 0x00;
  P6M0 = 0x00;
  P6M1 = 0x00;
  P7M0 = 0x00;
  P7M1 = 0x00;
	P1M0 |= 0xf0; P1M1 &= ~0xf0; //PWMΪģʽ

  UsbInit();
  PWM3_Flag = 0;
  PWM4_Flag = 0;

  PWM3_Duty = 512;
  PWM4_Duty = 1024;

  P1SR = 0x00;       //IOڵƽתٶȼӿΪP17P16P15P14

	
  PWMA_PS = 0x00;  //߼ PWM ͨѡλ
  PWMA_PS |= PWM3_0; //ѡ PWM3_0 ͨ
  PWMA_PS |= PWM4_0; //ѡ PWM4_0 ͨ

  Timer0_Config(Timer0_Reload);
	
  P34=1;
  EA = 1;
  HidOutput[0]=0xaa;
  HidOutput[1]=0x55;
  HidOutput[2]=0x02;
  for(i=3; i<64; i++) HidOutput[i] = 0;
  PllConfig();
  HSPwmConfig();
	DelayXms(10);
	CLKSEL |= 0x40;			//HSPWM/HSSPIѡPLLʱΪʱԴ
  while (1)
    {
			
      if(B_1ms)   //1ms
        {
          B_1ms = 0;
          if(++HidOutput[60] >= 30)    //300ms
            {
              HidOutput[60] = 0;//ȷǷȷ
              if(++HidOutput[61] >= 30)    //300ms
                {
                  HidOutput[61] = 0;//ȷǷȷ
                  P34=~P34;
                }
            }
        }
    }
}

BYTE ReadReg(BYTE addr)
{
  BYTE dat;
  while (USBADR & 0x80);
  USBADR = addr | 0x80;
  while (USBADR & 0x80);
  dat = USBDAT;
  return dat;
}

void WriteReg(BYTE addr, BYTE dat)
{
  while (USBADR & 0x80);
  USBADR = addr & 0x7f;
  USBDAT = dat;
}

BYTE ReadFifo(BYTE fifo, BYTE *pdat)
{
  BYTE cnt;
  BYTE ret;
  ret = cnt = ReadReg(COUNT0);
  while (cnt--)
    {
      *pdat++ = ReadReg(fifo);
    }
  return ret;
}

void WriteFifo(BYTE fifo, BYTE *pdat, BYTE cnt)//ǰȽȳ˳д
{
  while (cnt--)
    {
      WriteReg(fifo, *pdat++);
    }
}

void UsbInit()
{
  P3M0 = 0x00;
  P3M1 = 0x03;
//  P_SW2 |= 0x80;
//  RSTFLAG = 0x07;
  IRC48MCR = 0x80;
  while (!(IRC48MCR & 0x01));
  P_SW2 &= ~0x80;
//  USBCLK = 0x00;
  USBCON = 0x90;
  IP2H |= 0x80;		//USB жȼΪ 3 ߼
  IP2 |= 0x80;
  WriteReg(FADDR, 0x00);
  WriteReg(POWER, 0x08);
  WriteReg(INTRIN1E, 0x3f);
  WriteReg(INTROUT1E, 0x3f);
  WriteReg(INTRUSBE, 0x00);
  WriteReg(POWER, 0x01);
  Ep0Stage.bStage = EPIDLE;
  IE2 |= 0x80;
}

void usb_isr() interrupt 25
{
  BYTE intrusb;
  BYTE intrin;
  BYTE introut;
  BYTE csr;//
  BYTE cnt;//
  WORD len;//ֽ
  intrusb = ReadReg(INTRUSB);  //ȡUSBԴжϱ־
  intrin = ReadReg(INTRIN1);   //ȡUSB˵INжϱ־λ(INTRIN1)
  introut = ReadReg(INTROUT1); //ȡUSB˵OUTжϱ־λ(INTROUT1)
  if (intrusb & RSTIF)         //0x04ȽϵõԴλźж
    {
      WriteReg(INDEX, 1);        //д
      WriteReg(INCSR1, INCLRDT);
      WriteReg(INDEX, 1);
      WriteReg(OUTCSR1, OUTCLRDT);
      Ep0Stage.bStage = EPIDLE;//0
    }
  if (intrin & EP0IF)          //0x01˵0NOUTжϱ־λЧ
    {
      WriteReg(INDEX, 0);
      csr = ReadReg(CSR0);     //ȡUSB˵0״̬Ĵ(CSR0)
      if (csr & STSTL)         //0X04λΪSTALLźŷɱ־λSTALLźźӲλá1λ塰0
        {
          WriteReg(CSR0, csr & ~STSTL);//дΪSTALLźű־λλ塰0
          Ep0Stage.bStage = EPIDLE;  //ֵ0
        }
      if (csr & SUEND)          //0x10 SETUPװ־һοƴDATAENDλд1֮ǰʱ
        //Ӳֻλá1SSUENDд1Ӳλ塰0
        {
          WriteReg(CSR0, csr | SSUEND);//д0X100x80дؽSETUP¼ɱ־SETUP¼
          //(SUEND)ҪSSUEND־λӲ⵽SSUENDд롰1ʱԶSUENDλ塰0
          //˵򵥾ǶSETUPװ־
        }
      switch (Ep0Stage.bStage)//ȡ־λ״̬
        {
        case EPIDLE:           //0ǳʼ
          if (csr & OPRDY)     // Ƿ0x01OUTݰ׼ɱ־յһOUTݰʱӲֻλá1
            //жϡλֻSOPRDYλд1ʱű塰0
            {
              Ep0Stage.bStage = EPSTATUS;//־λá1
              ReadFifo(FIFO0, (BYTE *)&Setup);
              ((BYTE *)&Ep0Stage.wResidue)[0] = Setup.wLengthH;//ݹҪֽλ
              ((BYTE *)&Ep0Stage.wResidue)[1]= Setup.wLengthL;//ݹҪֽλ
              switch (Setup.bmRequestType & REQUEST_MASK)//0x60㣬жϴ豸ͣ
                {
                case STANDARD_REQUEST://0x00豸
                  switch (Setup.bRequest)//ж
                    {
                    case SET_ADDRESS:     //0x05Ϊ豸Ψһĵַ
                      WriteReg(FADDR, Setup.wValueL);//д豸Ψһĵַ
                      break;

                    case SET_CONFIG://0x09Ϊ豸ĳ
                      WriteReg(INDEX, 1);
                      WriteReg(INCSR2, INMODEIN);
                      WriteReg(INMAXP, 8);
                      WriteReg(INDEX, 1);
                      WriteReg(INCSR2, INMODEOUT);
                      WriteReg(OUTMAXP, 8);
                      WriteReg(INDEX, 0);
                      break;

                    case GET_DESCRIPTOR://Ϊ0x06ȡ豸ĳֱ׼
                      Ep0Stage.bStage = EPDATAIN;//2ֵȥ
                      switch (Setup.wValueH)//ֶεֵָҪ͵͵ĸλָ豸15.12
                        {
                        case DESC_DEVICE://0x01ȡ豸
                          Ep0Stage.pData = DEVICEDESC;//ֵchar code DEVICEDESC[18];
                          len = sizeof(DEVICEDESC);//ȡݱֽ
                          break;

                        case DESC_CONFIG://0x02
                          Ep0Stage.pData = CONFIGDESC;//ֵchar code CONFIGDESC[41];
                          len = sizeof(CONFIGDESC);//ȡݱֽ
                          break;

                        case DESC_STRING://0x03
                          switch (Setup.wValueL)//ֶεֵָҪ͵͵ĵλָ豸15.12
                            {
                            case 0://LANGIDDESC
                              Ep0Stage.pData = LANGIDDESC;//ֵcode LANGIDDESC[4];
                              len = sizeof(LANGIDDESC);//ȡݱֽ
                              break;

                            case 1://MANUFACTDESC
                              Ep0Stage.pData = MANUFACTDESC;//ֵcode MANUFACTDESC[8];
                              len = sizeof(MANUFACTDESC);//ȡݱֽ//ȡݱֽ
                              break;

                            case 2://MANUFACTDESC
                              Ep0Stage.pData = PRODUCTDESC;//ֵcode PRODUCTDESC[30];
                              len = sizeof(PRODUCTDESC);//ȡݱֽ
                              break;

                            default:
                              Ep0Stage.bStage = EPSTALL;//-1б
                              break;
                            }
                          break;

                        case DESC_HIDREPORT://0x22
                          Ep0Stage.pData = HIDREPORTDESC;//ֵchar code HIDREPORTDESC[27];
                          len = sizeof(HIDREPORTDESC);//ȡݱֽ
                          break;

                        default:
                          Ep0Stage.bStage = EPSTALL;//-1б
                          break;
                        }
                      if (len < Ep0Stage.wResidue)//λǷ񳬹ֵͽֵ
                        {
                          Ep0Stage.wResidue = len;//ȡֽݽиֵ
                        }
                      break;

                    default:
                      Ep0Stage.bStage = EPSTALL;//-1б
                      break;
                    }
                  break;

                case CLASS_REQUEST://0x20豸
                  switch (Setup.bRequest)//ж
                    {
                    case GET_REPORT://0x01豸ӿڵĳ
                      Ep0Stage.pData = HidFreature;//ֵchar code HIDREPORTDESC[27];
                      Ep0Stage.bStage = EPDATAIN;
                      break;

                    case SET_REPORT://0x09豸ĳ
                      Ep0Stage.pData = HidFreature;//ֵBYTE xdata HidFreature[64];
                      Ep0Stage.bStage = EPDATAOUT;//ֵΪ3
                      break;

                    case SET_IDLE://0x0A豸ĳӿڵֵ
                      break;

                    case GET_IDLE://0x02
                    case GET_PROTOCOL://0x03һ豸ӿڻ˵ϵ
                    case SET_PROTOCOL://0x0BʵʱУͬĳ֡ʼ
                    default:
                      Ep0Stage.bStage = EPSTALL;//-1б
                      break;
                    }
                  break;

                default:
                  Ep0Stage.bStage = EPSTALL;//-1б
                  break;
                }

              switch (Ep0Stage.bStage)//жϱ־λڼ
                {
                case EPDATAIN://2
                  WriteReg(CSR0, SOPRDY);//0x40ΪOPRDY¼ɱ־
                  //ɴӶ˵OյݰҪSOPRDY־λӲ⵽SOPRDYд
                  //1ʱԶOPRDYλ塰0
                  goto L_Ep0SendData;//תL_Ep0SendDataǩ
                  break;

                case EPDATAOUT://3
                  WriteReg(CSR0, SOPRDY);//0x40ΪOPRDY¼ɱ־
                  //ɴӶ˵OյݰҪSOPRDY־λӲ⵽SOPRDYд
                  //1ʱԶOPRDYλ塰0
                  break;

                case EPSTATUS://1
                  WriteReg(CSR0, SOPRDY | DATEND);//0x400x08л㣬0x40ΪOPRDY¼ɱ־
                  //ɴӶ˵OյݰҪSOPRDY־λӲ⵽SOPRDYд
                  //1ʱԶOPRDYλ塰0ݽ0x08Ӧ½λд1 1
                  //һݰ󣬹̼IPRDYд1ʱ 2һ㳤ݰ󣬹̼PRDYд1
                  //ʱ 3һݰ󣬹̼SOPRDYд1ʱλӲԶ塰0
                  Ep0Stage.bStage = EPIDLE;//־λ0
                  break;

                case EPSTALL://-1
                  WriteReg(CSR0, SOPRDY | SDSTL);//0x400x20л㣬0x40ΪOPRDY¼ɱ־
                  //ɴӶ˵OյݰҪSOPRDY־λӲ⵽SOPRDYд
                  //1ʱԶOPRDYλ塰00X20յֵ߲֧ʱλд1
                  //ǰݴ䡣STALLźűͺӲԶλ塰0
                  Ep0Stage.bStage = EPIDLE;//־λ0
                  break;
                }
            }
          break;

        case EPDATAIN://ȡ־λ״̬2
          if (!(csr & IPRDY))//0x02㣬ȡNݰ׼ɱ־ڷ֮һʱӲλ塰0
//						1ݰѷʱ2ݰһSETUPʱ 3ݰһOUTʱ
            {
L_Ep0SendData://תλ
              cnt = Ep0Stage.wResidue > 64 ? 64 : Ep0Stage.wResidue;//ֵλ
              WriteFifo(FIFO0, Ep0Stage.pData, cnt);//λд
              Ep0Stage.wResidue -= cnt;//λ-cnt
              Ep0Stage.pData += cnt;//ݵλ+cnt
              if (Ep0Stage.wResidue == 0)//λ0
                {
                  WriteReg(CSR0, IPRDY | DATEND);//д0x020x08
                  //0x08ݽӦ½λд1 1һݰ󣬹̼PRDYд1ʱ
                  //2һ㳤ݰ󣬹̼PRDYд1ʱ 3һݰ󣬹̼SOPRDYд1ʱ
                  //0x02ӦڽһҪ͵ݰװ뵽˵0FO󣬽λá1
                  Ep0Stage.bStage = EPIDLE;    //Ʊ־λ״̬0
                }
              else
                {
                  WriteReg(CSR0, IPRDY);//д0x02ӦڽһҪ͵ݰװ뵽˵0FO󣬽λá1
                }
            }
          break;

        case EPDATAOUT://ȡ־λ״̬3
          if (csr & OPRDY)//70x01
            {
              cnt = ReadFifo(FIFO0, Ep0Stage.pData);//ȡ
              //ºȫһ
              Ep0Stage.wResidue -= cnt;
              Ep0Stage.pData += cnt;
              if (Ep0Stage.wResidue == 0)
                {
                  WriteReg(CSR0, SOPRDY | DATEND);
                  Ep0Stage.bStage = EPIDLE;
                }
              else
                {
                  WriteReg(CSR0, SOPRDY);
                }
            }
          break;
        }
    }

  if (intrin & EP1INIF)///0x02˵0NOUTжϱ־λЧ  USBָźжЧ
    {
      WriteReg(INDEX, 1);//д1
      csr = ReadReg(INCSR1);//ȡIN˵״̬Ĵ1(NCSR1)
      if (csr & INSTSTL)//0x20IN˵״̬Ĵ1(NCSR1)
        {
          WriteReg(INCSR1, INCLRDT);//IN˵״̬Ĵ1(NCSR1)
        }
      if (csr & INUNDRUN)//0x04IN˵״̬Ĵ1(NCSR1)
        {
          WriteReg(INCSR1, 0);//IN˵״̬Ĵ1(NCSR1)
        }
    }

  if (introut & EP1OUTIF)//0x02 1:˵1NжЧ
    {
      WriteReg(INDEX, 1);
      csr = ReadReg(OUTCSR1);//OUT˵״̬Ĵ1(OUTCSR1)
      if (csr & OUTSTSTL)//0x40STALLźűɺӲὫλá1ñ־塰0
        {
          WriteReg(OUTCSR1, OUTCLRDT);
        }
      if (csr & OUTOPRDY)//0x01OUTݰɱ־
        {
          ReadFifo(FIFO1, HidInput);//ȡݵHidInput
          WriteReg(OUTCSR1, 0);//ñ־塰0

          if((HidInput[0]==0xaa) && (HidInput[1]==0x55) && (HidInput[2]==0x01))
            {
              WriteReg(INDEX, 1);//USB˵Ĵ(INDEXѡΪ1
              WriteFifo(FIFO1, HidOutput, 64);
              WriteReg(INCSR1, INIPRDY);//:iNݰ׼ɱ־
            }
          if((HidInput[0]==0xaa) && (HidInput[1]==0x55) && (HidInput[2]==0x00))
            {
              USBCON=0x00;//USB
              USBCLK=0x00;//ֹͣUSBʱ
              IRC48MCR=0x00;//ֹͣ48MIRCʱ
//              sleep_ms(10);//ȴUSB߸λ
              IAP_CONTR=0X60;//λ
            }
        }
    }
}

char code DEVICEDESC[18] =
{
  0x12, //bLength(18);
  0x01, //bDescriptorType(Device);
  0x00,0x02, //bcdUSB(2.00);
  0x00, //bDeviceClass(0);
  0x00, //bDeviceSubClass0);
  0x00, //bDeviceProtocol(0);
  0x40, //bMaxPacketSize0(64);
  0xbf,0x34, //idVendor(34bf);
  0x03,0xf0, //idProduct(f003);
  0x00,0x01, //bcdDevice(1.00);
  0x01, //iManufacturer(1);
  0x02, //iProduct(2);
  0x00, //iSerialNumber(0);
  0x01, //bNumConfigurations(1);
};

char code CONFIGDESC[41] =
{
  0x09, //bLength(9);
  0x02, //bDescriptorType(Configuration);
  0x29,0x00, //wTotalLength(41);
  0x01, //bNumInterfaces(1);
  0x01, //bConfigurationValue(1);
  0x00, //iConfiguration(0);
  0x80, //bmAttributes(BUSPower);
  0x32, //MaxPower(100mA);
  0x09, //bLength(9);
  0x04, //bDescriptorType(Interface);
  0x00, //bInterfaceNumber(0);
  0x00, //bAlternateSetting(0);
  0x02, //bNumEndpoints(2);
  0x03, //bInterfaceClass(HID);
  0x00, //bInterfaceSubClass(0);
  0x00, //bInterfaceProtocol(0);
  0x00, //iInterface(0);
  0x09, //bLength(9);
  0x21, //bDescriptorType(HID);
  0x01,0x01, //bcdHID(1.01);
  0x00, //bCountryCode(0);
  0x01, //bNumDescriptors(1);
  0x22, //bDescriptorType(HID Report);
  0x1b,0x00, //wDescriptorLength(27);
  0x07, //bLength(7);
  0x05, //bDescriptorType(Endpoint);
  0x81, //bEndpointAddress(EndPoint1 as IN);
  0x03, //bmAttributes(Interrupt);
  0x40,0x00, //wMaxPacketSize(64);
  0x01, //bInterval(10ms);
  0x07, //bLength(7);
  0x05, //bDescriptorType(Endpoint);
  0x01, //bEndpointAddress(EndPoint1 as OUT);
  0x03, //bmAttributes(Interrupt);
  0x40,0x00, //wMaxPacketSize(64);
  0x01, //bInterval(10ms);
};

char code HIDREPORTDESC[27] =
{
  0x05,0x0c, //USAGE_PAGE(Consumer);
  0x09,0x01, //USAGE(Consumer Control);
  0xa1,0x01, //COLLECTION(Application);
  0x15,0x00, // LOGICAL_MINIMUM(0);
  0x25,0xff, // LOGICAL_MAXIMUM(255);
  0x75,0x08, // REPORT_SIZE(8);
  0x95,0x40, // REPORT_COUNT(64);
  0x09,0x01, // USAGE(Consumer Control);
  0xb1,0x02, // FEATURE(Data,Variable);
  0x09,0x01, // USAGE(Consumer Control);
  0x81,0x02, // INPUT(Data,Variable);
  0x09,0x01, // USAGE(Consumer Control);
  0x91,0x02, // OUTPUT(Data,Variable);
  0xc0, //END_COLLECTION;
};

char code LANGIDDESC[4] =
{
  0x04,0x03,
  0x09,0x04,
};

char code MANUFACTDESC[8] =
{
  0x08,0x03,
  'S',0,
  'T',0,
  'C',0,
};

char code PRODUCTDESC[30] =
{
  0x1e,0x03,
  'S',0,
  'T',0,
  'C',0,
  ' ',0,
  'U',0,
  'S',0,
  'B',0,
  ' ',0,
  'D',0,
  'e',0,
  'v',0,
  'i',0,
  'c',0,
  'e',0,
};

//========================================================================
// : void ADC_Config(void)
// : ADC.
// : NULL.
// : NULL.
// 汾: V1.0, 2012-10-22
//========================================================================
//========================================================================
// : void Timer0_Config(u16 tReload)
// : ʱ.
// : tReload: ʱʱ..
// : NULL.
// 汾: V1.0, 2012-10-22
//========================================================================
void Timer0_Config(WORD tReload)
{
//  AUXR = 0x80;    //Timer0 set as 1T, 16 bits timer auto-reload,
//  TH0 = (BYTE)(tReload / 256);
//  TL0 = (BYTE)(tReload % 256);
//  ET0 = 1;    //Timer0 interrupt enable
//  TR0 = 1;    //Tiner0 run
	
	AUXR |= 0x80;			//ʱʱ1Tģʽ
	TMOD &= 0xF0;			//öʱģʽ
	TL0 = 0x40;				//öʱʼֵ
	TH0 = 0xA2;				//öʱʼֵ
	TF0 = 0;				//TF0־
	TR0 = 1;				//ʱ0ʼʱ
	ET0 = 1;				//ʹܶʱ0ж
}


//========================================================================
// : WORD Get_ADC12bitResult(BYTE channel)
// : ѯһADC.
// : channel: ѡҪתADC.
// : 12λADC.
// 汾: V1.0, 2012-10-22
//========================================================================
/********************** Timer0 1msжϺ ************************/
void timer0 (void) interrupt 1
{
//  B_1ms = 1;      //1ms־

  if(!PWM3_Flag)
    {
      PWM3_Duty++;
      if(PWM3_Duty > PWM_PERIOD) PWM3_Flag = 1;
    }
  else
    {
      PWM3_Duty--;
      if(PWM3_Duty <= 0) PWM3_Flag = 0;
    }

  if(!PWM4_Flag)
    {
      PWM4_Duty++;
      if(PWM4_Duty > PWM_PERIOD) PWM4_Flag = 1;
    }
  else
    {
      PWM4_Duty--;
      if(PWM4_Duty <= 0) PWM4_Flag = 0;
    }

  UpdatePwm();
}

//========================================================================
// : bitsz(int *p,u8 i,u8 y)
// : BIN־.
// : int *p,u8 i,u8 y.
// : i.
// 汾: V1.0, 2012-11-22
//=========================================================================
void WritePWMA(u8	addr, u8 dat)
{
  while (HSPWMA_ADR &	0x80); //ȴǰһ첽д
  HSPWMA_DAT = dat;		   //׼Ҫд
  HSPWMA_ADR = addr &	0x7f;  //üӷʵַ,ֻҪԭXFRַĵ7λ
  //HSPWMA_ADDRĴλд0,ʾд
}

//========================================================================
// : delay(void)
// : ʱ. 
// : none.
// : none.
// 汾: V1.0, 2022-03-16
//========================================================================
void delay(void)
{
	u8	i;
	for	(i=0; i<100; i++);
}

//========================================================================
// : PllConfig(void)
// : PWMʱӳʼ.
// : none.
// : none.
// 汾: V1.0, 2022-03-16
//========================================================================
void PllConfig(void)
{

  USBCLK = 0x00;
  //IRCƵѡĴ
  IRCBAND&=0xbf;// ʹUSBܣ뱣USBCKS=1;USBCKS2=O;
  IRCBAND|=0x80;  //ʹUSBܣ뱣USBCKS=1;USBCKS2=O;
  //ѡCPUʱ
  CLKSEL &= 0xf0;//
  CLKDIV = 0x00;				//cpuʱԴƵ		
  //ѡPLLʱ
  CLKSEL|=0x80;	//ѡPLL144MΪPLLʱ
  //ѡPLLʱӷƵ,֤ʱΪ12M
  USBCLK |= 0x20;			//PLLʱ2Ƶ
  //PLL
  USBCLK |= 0x80;			//ʹPLLƵ
  delay();
  //ѡHSPWM/HSSPIʱ
  HSCLKDIV = 0x00;				//HSPWM/HSSPIʱԴƵ	
}


//========================================================================
// : HSPwmConfig(void)
// : PWMʼ.
// : none.
// : none.
// 汾: V1.0, 2022-03-16
//========================================================================
void HSPwmConfig(void)
{
	P_SW2 |= 0x80;  //չĴ(XFR)ʹ
  HSPWMA_CFG = 0x03;			//ʹPWMAؼĴ첽ʹ

  //ͨ첽ʽPWMAؼĴ
  WritePWMA((u8)&PWMA_CCER1, 0x00);		   //дCCMR1ǰCCxEرͨ
  WritePWMA((u8)&PWMA_CCER2, 0x00);		   //дCCMR2ǰCCxEرͨ
//	WritePWMA((u8)&PWMA_CCMR1, 0x60);			//ͨģʽPWMģʽ1
//	WritePWMA((u8)&PWMA_CCMR2, 0x60);			//ͨģʽPWMģʽ1
  WritePWMA((u8)&PWMA_CCMR3, 0x68);			//ͨģʽPWMģʽ1
  WritePWMA((u8)&PWMA_CCMR4, 0x68);			//ͨģʽPWMģʽ1
  WritePWMA((u8)&PWMA_CCER2, 0x55);			//ͨʹܺͼ ʹȫرգ͵ƽЧ
//	WritePWMA((u8)&PWMA_CCMR1, 0x68);			//PWMA_CCR1Ԥתع(ҪCC1E=1ſд)
//	WritePWMA((u8)&PWMA_CCMR2, 0x68);
  WritePWMA((u8)&PWMA_ENO, 0xf0);	//ʹPWMź˿
  WritePWMA((u8)&PWMA_CCR3H, (u8)(PWM3_Duty >> 8));	//PWMռձ
  WritePWMA((u8)&PWMA_CCR3L, (u8)PWM3_Duty);
  WritePWMA((u8)&PWMA_CCR4H, (u8)(PWM4_Duty >> 8));	//PWMռձ
  WritePWMA((u8)&PWMA_CCR4L, (u8)PWM4_Duty);
  WritePWMA((u8)&PWMA_ARRH,  (u8)(PWM_PERIOD >> 8));	//PWM
  WritePWMA((u8)&PWMA_ARRL,  (u8)PWM_PERIOD);
  WritePWMA((u8)&PWMA_DTR, 10);					//ûԳPWM
  WritePWMA((u8)&PWMA_BKR, 0x80);				//ʹ
  WritePWMA((u8)&PWMA_CR1, 0x81);				//ʹARRԤװأʼPWM
}

//========================================================================
// : UpdatePwm(void)
// : PWMռձ.
// : none.
// : none.
// 汾: V1.0, 2012-11-22
//========================================================================
void UpdatePwm(void)
{
  WritePWMA((u8)&PWMA_CCR3H, (u8)(PWM3_Duty >> 8));	//PWMռձ
  WritePWMA((u8)&PWMA_CCR3L, (u8)PWM3_Duty);
  WritePWMA((u8)&PWMA_CCR4H, (u8)(PWM4_Duty >> 8));	//PWMռձ
  WritePWMA((u8)&PWMA_CCR4L, (u8)PWM4_Duty);
}